unit UnComplex_log;

interface

TYPE  caspossible = 1..11;

      complex = record
                ree:real;
                ima:real;
                modu:real;
                arg:real;
                end;

      operande = array [1..5] of real;
      coeffpoly = array [0..9] of real;
      polynome = record
                 degre:byte;
                 reel:operande;
                 imag:operande;
                 pr:byte;
                 pi:byte;
                 R:coeffpoly;
                 end;


var  R               :array [1..20] of extended;
     Z               :array [1..20] of complex;
     RS,SUM,PROD,
     QUOT,PUISS      :complex;
     nloop,cp,
     npts,unitegrph,
     ncoeff          :integer;
     dep,pas,fr,
     binf,bsup,Df,w  :extended;
     cas             :caspossible;
     casdef,f_graph  :boolean;
     num,den,poly    :polynome;
     n,dg            :byte;

     function log (x:extended): extended;
     function dix_puissance (x:extended):extended;
     procedure Calcsuivcas;





implementation



function log (x:extended): extended;   { fonction log 10 }

begin
     log := LN (x) / LN (10);
end;


function dix_puissance (x:extended):extended;
begin
     dix_puissance := EXP (x * LN(10));
end;


{*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*}


                (* OPERATIONS SUR LES NOMBRES COMPLEXES *)


{*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*_*}




procedure MAG(var x:complex);

begin
     with x do begin
               modu:= sqrt(sqr(ree)+sqr(ima));
               if ree<>0 then begin
                              arg:=arctan(ima/ree);
                              if ree<0 then arg:=arg+PI;
                              end
               else if ima>0 then arg:=PI/2
                    else arg:=-PI/2;
               end;
end;

procedure PRI(var x:complex);

begin
     with x do begin
               ree:=modu*cos(arg);
               ima:=modu*sin(arg);
               end;
end;

PROCEDURE ADD(x,y:complex);

begin
     SUM.ree:=x.ree+y.ree;
     SUM.ima:=x.ima+y.ima;
end;

procedure MUL(x,y:complex);

begin
     PROD.modu:=x.modu*y.modu;
     PROD.arg:=x.arg+y.arg;
end;

PROCEDURE DIVIDE(x,y:complex);

begin
     QUOT.modu:=x.modu/y.modu;
     QUOT.arg:=x.arg-y.arg;
end;


PROCEDURE ELEVPUISS(x:complex;n:byte);
var p:byte;
begin
     PUISS:=x;p:=1;
     while p<> n do BEGIN
                      MUL(PUISS,x);
                      PUISS:=PROD;
                      p:=succ(p);
                      end;
end;


         (*  CONFIGURATION DE LA TRANSMITTANCE *)

procedure cas1;

begin
     RS.ree:=R[1];     RS.ima:=R[2]*w;
     MAG(RS);
     RS.modu:=1/RS.modu;  RS.arg:=-RS.arg;

end;

procedure cas2;

begin
     Z[1].ree:=R[1];    Z[1].ima:=R[2]*w;
     Z[2].ree:=R[3];    Z[2].ima:=R[4]*w;
     MAG(Z[1]);         MAG(Z[2]);
     DIVIDE(Z[1],Z[2]);
     RS:=QUOT;
end;

procedure cas3;

begin
     Z[1].ree:=R[1];    Z[1].ima:=R[2]*w;
     MAG(Z[1]);         ELEVPUISS(Z[1],round(R[3]));    Z[3]:=PUISS;
     Z[2].ree:=R[4];    Z[2].ima:=R[5]*w;
     MAG(Z[2]);         ELEVPUISS(Z[2],round(R[6]));    Z[4]:=PUISS;
     DIVIDE(Z[3],Z[4]);
     RS:=QUOT;
end;

procedure cas4;   { cas2 x cas2 }
var tmpRS : complex;
begin
     cas2;
     tmpRS := RS;
     R[1] := R[5];
     R[2] := R[6];
     R[3] := R[7];
     R[4] := R[8];
     cas2;
     MUL (RS,tmpRS);
     RS := PROD;
end;


procedure denom456;

begin
     Z[2].ree:=R[4]-R[2]*w*w;     Z[2].ima:=R[3];
     MAG(Z[2]);
end;

procedure cas7;

begin
     Z[1].REE:=R[1];       Z[1].IMA:=0;    MAG(Z[1]);
     Z[2].REE:=R[2];       Z[2].IMA:=R[3]*w; MAG(Z[2]);
     ELEVPUISS(Z[2],ROUND(R[4]));  Z[2]:=PUISS;
     Z[3].REE:=R[5];       Z[3].IMA:=R[6]*w; MAG(Z[3]);
     ELEVPUISS(Z[3],ROUND(R[7]));
     MUL(PUISS,Z[2]);      Z[3]:=PROD;
     DIVIDE(Z[1],Z[3]);
     RS:=QUOT;

end;

procedure CalcReelImaPoly(var poly:polynome;var z0:complex); FORWARD;

procedure cas10;

begin
     if w=0 then begin
                 Z[1].ree:=num.reel[num.pr]; Z[1].ima:=0;
                 Z[2].ree:=den.reel[num.pr]; Z[2].ima:=0;
                 end
     else   begin
            CalcReelImaPoly(num,Z[1]);
            CalcReelImaPoly(den,Z[2]);
            end;
     MAG(Z[1]);     MAG(Z[2]);      DIVIDE(Z[1],Z[2]);
     RS:=QUOT;
end;

             (* PROCEDURES DE CALCUL SUR LES POLYNOMES *)

procedure npair(var poly:polynome);

begin
     with poly do begin
     if (n mod 4)=0 then reel[pr]:=R[n]
                    else reel[pr]:=-R[n];
     pr:=pr+1;
     n:=n-1;
                  end;
end;

procedure nimpair(var poly:polynome);

begin
     with poly do begin
     if (n mod 4)=3 then imag[pi]:=-R[n]
                    else imag[pi]:=R[n];
     pi:=pi+1;
     n:=n-1;
                   end;
end;

procedure degrepair(var poly:polynome);

begin
     repeat
           npair(poly);
           nimpair(poly);
     until n=0;
end;

procedure degreimpair(var poly:polynome);

begin
     repeat
           nimpair(poly);
           if n<>0 then npair(poly);
     until n=0;
end;

procedure separereelimag(var poly:polynome);

begin
     with poly do
     begin
       pr:=1;pi:=1;
       n:=degre;
       if n<>0 then if (n mod 2)=0 then degrepair(poly)
               else degreimpair(poly);
       reel[pr]:=R[0];
       pi:=pi-1;
     end;
end;

procedure CalcReelImaPoly;  {(var poly:polynome;var z0:complex);}
var pt : byte;
begin

     z0.ree:=0;dg:=0;
     for pt:= poly.pr downto 1 do
         begin
              z0.ree:=z0.ree+exp(dg*ln(w))*poly.reel[pt];
              dg:=dg+2;
         end;

     z0.ima:=0;dg:=1;
     if poly.degre<> 0 then begin
         for pt:=poly.pi downto 1 do
         begin
              z0.ima:=z0.ima+exp(dg*ln(w))*poly.imag[pt];
              dg:=dg+2;
         end;
                       end;
end;




procedure Calcsuivcas;

begin
     case cas of
          1:cas1;
          2:cas2;
          3:cas3;
          4:cas4;
          7:cas7;
         10:cas10;
          end;
end;





end.
