unit UnModule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, UNComplex_log;

type
   memo_points = array [0..1280] of integer;

  TFL_module = class(TForm)
    StatusBar1: TStatusBar;
  procedure FormCreate (Sender : TObject);
  procedure FormPaint (Sender : TObject);
  procedure Resize (Sender : Tobject);
  procedure Line (x0,y0,x1,y1 :integer);
  function  xgraph (xm :real): integer;
  procedure Graphique;
  procedure Trace(Z:complex);
  procedure tracepoints;
  procedure pave_def (x,y:integer; s:string);
  procedure complete_courbe (memY : memo_points);
  procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Dclarations prives }
  public
    maxX : integer;
    maxY : integer;
    xorig,yorig        : integer;
    Y_TOP              : integer;
    memo_factagY       : extended;
    gr_uniteY          : extended;
    couleur_courbe     : integer;
    xg,yg              : integer;

    rap,xm,p1,p2     : extended;
    diz,resolution   : integer;
    val_init,e       : extended;
    s                : string [12];
    ngradneg,ngradpos: integer;
    raison,g         : integer;
    val_gradX        : array [0..100] of extended;

    coul_pave_def    : integer;       {couleur de fond des pavs dB et Hz}


  end;

var
  FL_module: TFL_module;

implementation

{$R *.DFM}

uses Lieux_Bode;


procedure TFL_module.FormCreate (Sender : TObject);
begin
 p1 := 1;
 p2 := 10000;
 memo_factagY := 1;

end;


procedure TFL_module.FormPaint (Sender : TObject);
var j : integer;
begin

 maxX := ClientWidth;
 maxY := ClientHeight;

 for j:= 1 to maxY do begin
                         mem1_y[j] := 0;
                         mem2_y[j] := 0;
                         end;
 Xorig := 0;
 Yorig := round (maxY/2);

 gr_uniteY := 20 * (maxX/maxY) * memo_factagy;
 Color := clWhite;
 Canvas.Pen.color := clBlack;
 Couleur_courbe := clRed;
 coul_pave_def := clAqua;
 //     recale_graduations;
     Graphique;
     tracepoints;
//    factagp := 1;
//     trace_phase;

end;


procedure TFL_module.Resize (Sender : TObject);
begin
  Canvas.FillRect (Canvas.ClipRect);
  FormPaint (sender);
end;

procedure TFL_module.Line (x0,y0,x1,y1 :integer);
begin
   With Canvas do
   begin
     MoveTo (x0,y0);
     LineTo (x1,y1);
   end;
end;


function TFL_module.xgraph (xm :real): integer;      {trouve le x graphique}
begin
     xgraph := round (Log (xm/p1) / log (p2/p1) * maxX);
end;


procedure TFL_module.Graphique;
var n,j : integer;
    memStyle : TFontStyles;
    fmt      : longint;

 procedure ligne_verticale;
          begin
               line (xg,yg,xg,0);
          end;

 procedure gradue_y;
                    procedure gradue;
                    begin
                            line (0,yg,maxX,yg);
                            Canvas.Textout(2,yg,s);
                    end;
          begin
           if (yg <> 0) AND (raison = 0) then gradue
           else
           if (yg <> 0)
           AND (n mod(raison)=0) then gradue;
          end;


begin
     gr_uniteY := 20 * (maxX/maxY) * memo_factagy;
     Y_TOP := maxY - 16;
     Xorig  := 0;
     line (0,Yorig,maxX,Yorig);

     { graduations }
     { axe des x }
     Canvas.Pen.Color := clTeal;

     rap := log (p2 /p1);
     diz := round (rap);

     resolution := 10 ;
     val_init := p1;

     yg := Y_TOP -20;
     memStyle := Canvas.Font.Style;

     if rap >= 1 then
     for n := 1 to diz   do        {graduations des X : lignes verticales}
     begin
          Canvas.Font.Style := [fsBold];
          xm := val_init;
          xg := xgraph (xm);
          ligne_verticale;
          e := log (val_init);
          fmt := round (e);
          if e < 5 then str(xm:fmt:0,s) else begin
                                           str(e:2:0,s);
                                           s := '1E'+ s;
                                           end;
          Canvas.Textout(xg,yg,s);
          Canvas.Font.Style := memStyle;
          for j := 2 to 8 do
          begin
          xm := val_init * j;
          xg := xgraph (xm);
          str(j:1,s);
          if diz <= 5 then Canvas.Textout(xg,yg,s);
          ligne_verticale;
          end;

          val_init := val_init * resolution;
     end

     else { diz < 1 }
     begin
          for  j := 0 to 20 do
          begin
         // xm := val_gradX [j];
          xg := xgraph (xm);
          ligne_verticale;
          if j mod(3)=0 then
                        begin
                                  str(xm:10:0,s);
                                  Canvas.Textout(xg,yg,s);
                        end;
          end;
     end;


      {axe des y}
     ngradneg := round(int( (Y_TOP-Yorig)/gr_uniteY));
     ngradpos := round(int(Yorig/gr_uniteY));
     raison := round(int(ngradpos+ngradneg)/20);

     g := 1;
     for n := 1 to ngradpos do        {graduations des Y >  0
                                                    : lignes horizontales}
     begin
          str(g,s);
          yg := round( Yorig - gr_uniteY * n);
          gradue_y;
          g := g + 1;
     end;

     g := 0;
     for n := 0 to ngradneg do        {graduations des Y <= 0
                                                    : lignes horizontales}
     begin
          str(-g,s);

          yg := round(Yorig + gr_uniteY * n);
          gradue_y;
          g := g + 1;
     end;

end;

procedure TFL_module.pave_def (x,y:integer; s:string);
var l:integer;
    savBrushColor,savFontColor : Longint;

begin
   with Canvas do
   begin
     savbrushcolor := brush.color;
     brush.color := coul_pave_def;
     savFontcolor := Font.color;
     Font.Color := clRed;
     Font.Style := [fsBold];
     Font.Size := Font.Size + 3;
     l := length (s);
     Fillrect (Rect (x,y,x+8*l,y+10) );
     TextOUT (x+2,y+2,s);
     Font.Style := Font.Style - [fsBold];
     Font.Size := Font.Size - 3;
     Font.Color := savFontColor;
     Brush.color := SavBrushColor;
   end;

end;

procedure TFL_module.Trace(Z:complex);
begin
       xg := xgraph (fr);
       yg := round( Yorig - gr_uniteY * 20*log(z.modu));
       mem1_y[xg] := yg;
//       mem2_y[xg] := round(- page_gr[phase].gr_uniteY * z.arg);
       Canvas.pixels [xg,yg] := couleur_courbe;
end;


procedure TFL_module.tracepoints;
var cp : integer;
begin
     pave_def(0,0,'dB');
     pave_def(maxX-18,Y_TOP-40,'Hz');
     kp2p1 := log (p2/p1);
     kp1   := log (p1);
     cp := 0;
     repeat
     fr := xF (cp);
     w:=2*PI*fr;
     Calcsuivcas;
     Trace(RS);
     Inc (cp);
     until cp = maxX + 1;
     complete_courbe (mem1_Y);

end;

procedure TFL_module.complete_courbe (memY : memo_points);
var n,j : integer;
begin
              with Canvas do
              begin
                n := 0;
                Moveto (n, memy[0]);
                Pen.color := couleur_courbe;
                for j := 1 to maxX do
                    begin
                         lineTo(j,memy[j]);
                         moveTo(j,memy[j]);
                    end;
             end;
end;

procedure TFL_module.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caFree;
 FC_trans.Close;
end;

end.
